var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
import { withTranslate } from 'ra-core';
import MenuItem from '@material-ui/core/MenuItem';
import { Link } from 'react-router-dom';
/**
 * Menu item meant to be used inside a <TreeNodeActionsMenu>. It provides a custom create button
 * which will initialize the create form with values to insert a new node after the current one
 *
 * @example
 * const TagNodeActions = props => (
 *     <TreeNodeActions {...props}>
 *         <TreeNodeActionsMenu {...props}>
 *             <AddNodeBeforeMenuItem />
 *             <AddNodeAfterMenuItem />
 *         </TreeNodeActionsMenu>
 *     </TreeNodeActions>
 * );
 * export const TagsList = (props) => (
 *     <Tree {...props}>
 *         <TreeList>
 *             <TreeNode actions={<TagNodeActions />}>
 *                 <TextField source="name" />
 *             </TreeNode>
 *         </TreeList>
 *     </Tree>
 * );
 */
var AddNodeAfterMenuItemView = function (_a) {
    var basePath = _a.basePath, _b = _a.label, label = _b === void 0 ? 'ra.tree.add_node_after' : _b, parentSource = _a.parentSource, positionSource = _a.positionSource, siblingRecord = _a.record, translate = _a.translate, props = __rest(_a, ["basePath", "label", "parentSource", "positionSource", "record", "translate"]);
    var _c;
    // This record will be used to initialize the form values for the new node
    var record = (_c = {},
        // The new node will have the same parent as the node after which it will be inserted
        _c[parentSource] = siblingRecord[parentSource],
        // The new node will be inserted after its sibling
        _c[positionSource] = siblingRecord[positionSource] + 1,
        _c);
    return (React.createElement(MenuItem
    // @ts-ignore
    , __assign({ 
        // @ts-ignore
        component: Link, to: {
            pathname: basePath + "/create",
            state: { record: record },
        }, label: label }, props), translate(label)));
};
var AddNodeAfterMenuItem = withTranslate(
// @ts-ignore
AddNodeAfterMenuItemView);
export default AddNodeAfterMenuItem;
